/************************************************************************
 * Purpose:     A program to experiment with communications in a ring. 
 *
 * Author:      Ronald Lau CPS615
 *
 ************************************************************************/

#include	<stdio.h>
#include	<mpi.h>

float buffer[1000];

void main ( int argc, char *argv[] )
{
     int ierror, rank, size, p, finish, time, start, ping, pong;
     int flag=1;
     int done=0;
     int length=1000;

     MPI_Request srequest;
     MPI_Request rrequest;
     MPI_Status status;

     MPI_Init(&argc, &argv);

     MPI_Comm_rank(MPI_COMM_WORLD, &rank);

     /* Find out number of processes */
     MPI_Comm_size(MPI_COMM_WORLD, &p);

     ping = rank;

     start = MPI_Wtime();

     while(done != 1)
     {
        if(flag == 1)
        {
           if(rank+1>=p)
           {
              MPI_Issend(buffer, length, MPI_FLOAT, 0, ping,
                      MPI_COMM_WORLD, &srequest);
           }
           else
           {
              MPI_Issend(buffer, length, MPI_FLOAT, rank+1, ping,
                     MPI_COMM_WORLD, &srequest);
           }
        }

        MPI_Irecv(buffer, length, MPI_FLOAT, rank-1, pong,
                     MPI_COMM_WORLD, &rrequest);

        if(pong == rank)
        { 
           done = 1;
           finish = MPI_Wtime();
        }
        MPI_Test(srequest, &flag, &status);
     }


     time = finish - start;

     printf("Total Time = %d\n", time/200.);

     MPI_Finalize();
}
